<?php
/**************************** ApacheLogFormatter ******************************/
class ApacheLogFormatter extends LogFormatter {

	function ApacheLogFormatter() {
		LogFormatter::LogFormatter();
		$this->tag = "apache";
		$this->header = "IP" .FIELD_DELIMITER ."Date" .FIELD_DELIMITER ."Time" .FIELD_DELIMITER ."TZone" .FIELD_DELIMITER ."Method" .FIELD_DELIMITER ."Request" .FIELD_DELIMITER ."Protocol" .FIELD_DELIMITER ."Status" .FIELD_DELIMITER ."Size" .FIELD_DELIMITER ."Domain" .FIELD_DELIMITER ."Referer" .FIELD_DELIMITER ."UserAgent";
	}
	
	function FormatLine($line) {
	// format:  IP n/a User [Date+Time Zone] Request Status Size Server Referer UserAgent ?
		// $aElements = ExplodeQuoted($line, " ");
		$aElements = String2Array($line, '%IP% - %User% \[%Day%/%Month%/%Year%:%Hour%:%Min%:%Sec% %TimeZone%\] "%Method% %Request% %Protocol%" %Status% %Size% %Domain% "%Referer%" "%UserAgent%" "-"');
		// DebugOut("aElements", $aElements);
		
		$dt=strtotime($aElements["Year"] ."-" .$aElements["Month"] ."-" .$aElements["Day"]);
		$timeStamp = mktime($aElements["Hour"], $aElements["Min"], $aElements["Sec"], date("m", $dt), date("d", $dt), date("Y", $dt));
		$date = date("Y-m-d", $timeStamp);
		$time = date("H:i:s", $timeStamp);
		
		$result = $aElements["IP"] .
			FIELD_DELIMITER .$date .
			FIELD_DELIMITER .$time .
			FIELD_DELIMITER .$aElements["TimeZone"] .
			FIELD_DELIMITER .$aElements["Method"] .
			FIELD_DELIMITER .$aElements["Request"] .
			FIELD_DELIMITER .$aElements["Protocol"] .
			FIELD_DELIMITER .$aElements["Status"] .
			FIELD_DELIMITER .$aElements["Size"] .
			FIELD_DELIMITER .$aElements["Domain"] .
			FIELD_DELIMITER .$aElements["Referer"] .
			FIELD_DELIMITER .$aElements["UserAgent"];
			
		return($result);
	}	
}


/**************************** ApacheErrorLogFormatter ******************************/
class ApacheErrorLogFormatter extends LogFormatter {
	function ApacheErrorLogFormatter() {
		LogFormatter::LogFormatter();
		$this->tag = "apache-error";
		$this->header = "Date" .FIELD_DELIMITER ."Time" .FIELD_DELIMITER ."Tag" .FIELD_DELIMITER ."Source" .FIELD_DELIMITER ."Message";
		$this->startColSource = 28;
		$this->delimEndSource = "]";
	}
	
	function GetDateTime($line) {
	// [ddd mmm dd hh:mm:ss yyyy]
		// $dummy = substr($line, 0, 3); // day name
		$month = MonthNameToInt(substr($line, 5, 3));	// Jan Feb etc. -> 1,2..
		$day = ltrim(substr($line, 9, 2));
		$time = substr($line, 12, 8);
		$year = substr($line, 21, 4);
		$aTime = explode(":", $time);
		// DebugOut("month", $month); DebugOut("day", $day); DebugOut("time", $time); DebugOut("year", $year);
		
		$timeStamp = mktime($aTime[0], $aTime[1], $aTime[2], $month, $day, $year);
		$dateTime = date("Y-m-d" .FIELD_DELIMITER ."H:i:s", $timeStamp);
		
		return($dateTime);
	}
	
}

Register("apache", "ApacheLogFormatter");
Register("apache-error", "ApacheErrorLogFormatter");

?>