<?php

/**************************** VMWareLogFormatter ******************************/
class VMWareLogFormatter extends LogFormatter {
	
	function VMWareLogFormatter() {
		LogFormatter::LogFormatter();
		$this->tag = "vmware";
		$this->startColSource = 21;
		$this->delimEndSource = "|";
	}
	
}


/**************************** VMWareLogFormatter ******************************/
class VMWareServerDLogFormatter extends VMWareLogFormatter {
	
	function VMWareServerDLogFormatter() {
		VMWareLogFormatter::VMWareLogFormatter();
		$this->tag = "vm-srv";
		$this->startColSource = 17;
	}
	
}



/**************************** VMWareAuthdFormatter ******************************/
class VMWareAuthdLogFormatter extends VMWareLogFormatter {
	function VMWareAuthdFormatter() {
		VMWareLogFormatter::VMWareLogFormatter();
		$this->tag = "vm-auth";
		$this->startColSource = 17;
	}
}



/**************************** VMWareLogFormatter ******************************/
class VMWareLog2Formatter extends VMWareLogFormatter {
// multi-line message format

	var $lineBegin;
	
	function VMWareLog2Formatter() {
		VMWareLogFormatter::VMWareLogFormatter();
		$this->tag = "vmwarex";
		$this->startColSource = 24;
		$this->delimEndSource = "]";
		
		$this->lineBegin = "[";
	}


	function GetDateTime($line) {
		// 2009-09-28 13:43:31.120
		list($date, $time) = explode(" ", substr($line, 0, $this->startColSource-1));	
		$aDate = explode("-", $date);
		$aTime = explode(":", $time);

		$timeStamp = mktime($aTime[0], $aTime[1], $aTime[2], $aDate[1], $aDate[2], $aDate[0]);
		$dateTime = date("Y-m-d" .FIELD_DELIMITER ."H:i:s", $timeStamp);
		
		return($dateTime);
	}
	
	
	function OutputLoop($lines) {
	
		$iCount = count($lines);
		$currentLine = "";
		$isLast = FALSE;
		for ($this->lineCount = 0; $this->lineCount <= $iCount; $this->lineCount++) {  // count 1 more (last line)
		
			if (!$isLast) {
				$line = rtrim($lines[$this->lineCount]);
			} else {
				// $line = $currentLine; // see "isContinued" check
			}
			
			if ($this->lineCount > 0) {	// suppress line 1
				
				$isContinued = (substr($line, 0, 1) != $this->lineBegin);	// multi-line continued?
				if ( (!$isContinued) || ($isLast) ) {	// [  or last line
					// output $currentLine
					if (!empty($currentLine)) {
						// echo "--------------------->" .OUTPUT_NEWLINE;
						$currentLine = $this->FormatLine($currentLine);
						echo $currentLine .OUTPUT_NEWLINE;
					}
					
					$currentLine = $line;	// remember
				} else {	// multi-line continued
					$currentLine .= OUTPUT_SOFT_CR .ltrim($line);
				}
				
				$isLast = ($this->lineCount == $iCount-1);	// last line?
				
			}
		}
		
	}
	
}


/**************************** VMWareHostdFormatter ******************************/
class VMWareHostdLogFormatter extends VMWareLog2Formatter {
	function VMWareHostdLogFormatter() {
		VMWareLog2Formatter::VMWareLog2Formatter();
		$this->tag = "vm-host";
	}
}


/**************************** VMWareHostdFormatter ******************************/
class VMWareProxyLogFormatter extends VMWareLog2Formatter {
	function VMWareProxyLogFormatter() {
		VMWareLog2Formatter::VMWareLog2Formatter();
		$this->tag = "vm-proxy";
		$this->startColSource = 20;
	}
}

Register("vmware", "VMWareLogFormatter");
Register("vmware-serverd", "VMWareServerDLogFormatter");
Register("vmware-hostd", "VMWareHostdLogFormatter");
Register("vmware-vmauthd", "VMWareAuthdLogFormatter");
Register("vmware-proxy", "VMWareProxyLogFormatter");

?>